<?php
/*
Animation code by Marcello (http://www.cellosoft.com). Modified by RanmaGuy. Used with permission. This file is not to be used with any other script other than OekakiPoteto.

Wax Poteto modifications Copyright Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 5.6.0 - Last modified 6/19/2007
*/


/*
NOTES:

Cookies don't [aren't supposed to] work with POST, so we get $OekakiU from applet and load boot.php later.  All variables end up in keyed array $params.  We process that first before adding the bootstrap.  Note that everything comes from CGI, so addslashes() as needed!

Special error reporting is needed, because errors are return codes sent to the applet, not the web browser.

*/


// Error reporting
function print_ok() {
	global $dbconn;
	@mysql_close ($dbconn);

	header('Content-type: text/plain');
	exit ('ok');
}
function quiet_exit($exit_err) {
	global $dbconn;
	@mysql_close ($dbconn);

	header ('Content-type: text/plain');
	echo "error\n";
	exit ($exit_err);
}


// Get raw POST data (reference test saves memory)
if (empty ($HTTP_RAW_POST_DATA)) {
	$raw_buffer = file_get_contents ('php://input');
} else {
	$raw_buffer =& $HTTP_RAW_POST_DATA;
}


// Parse input for login
if (substr ($raw_buffer, 0, 1) == 'P') {
	// Header
	$image['h_length'] = substr ($raw_buffer, 1, 8);
	$image['h_length'] = (int) $image['h_length'];
	$image['h_data']   = substr ($raw_buffer, 9, $image['h_length']);

	$params = array ();
	$pairs = explode(';', $image['h_data']);
	for ($i = count ($pairs); --$i >= 0;) {
		$keyvals = explode ('=', $pairs[$i]);
		$params[$keyvals[0]] = $keyvals[1];
	}
} else {
	w_error_log(__FILE__.": No_Parameters");
	$params['usr'] = NULL;
}


// Load bootstrap, quiet mode
$OekakiU    = addslashes (utf8_decode ($params['usr']));
$OekakiPass = addslashes ($params['vcode']);
if (empty ($OekakiU)) {
	// English only
	w_error_log (__FILE__.": BadLogin: params_count-".count ($params));
	quiet_exit('Login could not be verified!  Take a screenshot of your picture.');
}
$quiet_mode = TRUE;
$no_online = TRUE;
define ('BOOT', 1);
w_error_log(__FILE__.": Load Boot");
require ('boot.php');
w_error_log(__FILE__.": Load Paintsave");
require ('paintsave.php');


// Clean input
$mode      = $params['mode'];
$edittimes = (int) $params['edittimes'];
$edit      = (int) $params['edit'];
$import    = (int) $params['import'];
$user_pass = ''; // Wacintaki only


// Test input
if (empty ($raw_buffer)) {
	// No data to save!
	w_error_log(__FILE__.": No_RAW_Data");
	quiet_exit($langop_err_nodata);
}
if (substr ($raw_buffer, 0, 1) != 'P') {
	w_error_log(__FILE__.": No_P_Header");
	quiet_exit($langop_poo_compat." '<param name=\"poo\" value=\"false\" />'");
}


// PaintBBS data
if (substr ($raw_buffer, 0, 1) == 'P') {
	// Image data
	$image['o_length'] = substr ($raw_buffer, $image['h_length'] + 9, 8);
	$image['o_length'] = (int) $image['o_length'];
	$image['o_data']   = substr ($raw_buffer, $image['h_length'] + 19, $image['o_length']);

	// Animation
	$image['t_length'] = substr ($raw_buffer, $image['h_length'] + $image['o_length'] + 19, 8);
	$image['t_length'] = (int) $image['t_length'];
	$image['t_data']   = substr ($raw_buffer, $image['h_length'] + $image['o_length'] + 27, $image['t_length']);

	// Thumbnail
	$image['t2_length'] = substr ($raw_buffer, $image['h_length'] + $image['o_length'] + $image['t_length'] + 27, 8);
	$image['t2_length'] = (int) $image['t2_length'];
	$image['t2_data']   = substr ($raw_buffer, $image['h_length'] + $image['o_length'] + $image['t_length'] + 35, $image['t2_length']);
} else {
	w_error_log (__FILE__.": Bad format (no 'P')");
}

// Check image
if (empty ($image['o_data'])) {
	w_error_log (__FILE__.": No image data.  User: $OekakiU");
	quiet_exit($langop_err_nodata);
}
w_error_log (__FILE__.": Pass parse.  User: $OekakiU");

// Is animation too big?
if ($image['t_length'] > $cfg['max_anim']) {
	$image['t_length'] = 0;
	$image['t_data'] = NULL;
}


// Insert new slot into database
if ($mode == 'norm' || $mode == 'anim') {
	$resno = get_new_picnumber();
	if ($resno == 0) {
		w_error_log (__FILE__.": Cannot allocate new PIC_ID.  User: $OekakiU");
		quiet_exit($langop_err_picts);
	} else {
		w_error_log (__FILE__.": Slot-{$resno}  User: $OekakiU");
	}

	// Cleanup slots
	$result = clean_picture_slots();
	w_error_log ("OK-clean.  User: $OekakiU");

	$thetime = time() - $edittimes;

	// Insert new slot
	$tries = 5;
	while ($tries > 0) {
		$sqlres = "INSERT INTO {$OekakiPoteto_Prefix}oekakidta SET usrname='$OekakiU', postdate=NOW(), hostname='$hostname', comment='', PIC_ID='$resno', IP='$address', datatype=0, edittime='$thetime', password=''";
		if ($mode == 'anim') {
			$sqlres .= ', animation=1';
		} else {
			$sqlres .= ', animation=0';
		}
		$result = mysql_query ($sqlres);

		if ($result) {
			$tries = 0;
		} else {
			$tries--;
			sleep (1);
		}
	}
	if (!$result) {
		w_error_log (__FILE__.": DB cannot save image.  User: $OekakiU, Number: $resno, SQL: ".mysql_error());
		quiet_exit($langop_err_saveimg);
	} else {
		w_error_log (__FILE__.": DB-OK, slot-{$resno}.  User: $OekakiU");
	}
}


// Update edited slot to database
if ($mode == 'edit') {
	// Verify edit, otherwise invalidate it
	$resno = verify_edit($edit, $user_pass);

	$edittime2 = time() - $edittimes;
	$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET edittime=(edittime + $edittime2) WHERE PIC_ID='$resno'");
}


// Write files
//
// Save image/anim data.  Filetype is automatic!
if (!save_image($image['o_data'], $resno)) {
	w_error_log (__FILE__.": Cannot save image.  Look for temp image.  User: $OekakiU, Number: $resno");
	quiet_exit($langop_err_saveimg);
} else {
	w_error_log (__FILE__.": Image-OK.  User: $OekakiU");
}
if (!empty ($image['t_data'])) {
	save_anim($image['t_data'], $resno, 'pch');
}


print_ok();

?>